diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/seq-ts-size-header.h ns-3.44/src/applications/model/seq-ts-size-header.h
--- ns-3.43/src/applications/model/seq-ts-size-header.h	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/seq-ts-size-header.h	2025-03-09 16:55:49.347370900 -0700
@@ -14,8 +14,8 @@
 namespace ns3
 {
 /**
- * \ingroup applications
- * \brief Header with a sequence, a timestamp, and a "size" attribute
+ * @ingroup applications
+ * @brief Header with a sequence, a timestamp, and a "size" attribute
  *
  * This header adds a size attribute to the sequence number and timestamp
  * of class \c SeqTsHeader.  The size attribute can be used to track
@@ -27,25 +27,25 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
     /**
-     * \brief constructor
+     * @brief constructor
      */
     SeqTsSizeHeader();
 
     /**
-     * \brief Set the size information that the header will carry
-     * \param size the size
+     * @brief Set the size information that the header will carry
+     * @param size the size
      */
     void SetSize(uint64_t size);
 
     /**
-     * \brief Get the size information that the header is carrying
-     * \return the size
+     * @brief Get the size information that the header is carrying
+     * @return the size
      */
     uint64_t GetSize() const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/sink-application.cc ns-3.44/src/applications/model/sink-application.cc
--- ns-3.43/src/applications/model/sink-application.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/applications/model/sink-application.cc	2025-03-09 16:55:49.347370900 -0700
@@ -0,0 +1,85 @@
+/*
+ * Copyright (c) 2024 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "sink-application.h"
+
+#include "ns3/log.h"
+#include "ns3/uinteger.h"
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("SinkApplication");
+
+NS_OBJECT_ENSURE_REGISTERED(SinkApplication);
+
+TypeId
+SinkApplication::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::SinkApplication")
+            .SetParent<Application>()
+            .SetGroupName("Applications")
+            .AddAttribute(
+                "Local",
+                "The Address on which to Bind the rx socket. "
+                "If it is not specified, it will listen to any address.",
+                AddressValue(),
+                MakeAddressAccessor(&SinkApplication::SetLocal, &SinkApplication::GetLocal),
+                MakeAddressChecker())
+            .AddAttribute(
+                "Port",
+                "Port on which the application listens for incoming packets.",
+                UintegerValue(INVALID_PORT),
+                MakeUintegerAccessor(&SinkApplication::SetPort, &SinkApplication::GetPort),
+                MakeUintegerChecker<uint32_t>());
+    return tid;
+}
+
+SinkApplication::SinkApplication(uint16_t defaultPort)
+    : m_port{defaultPort}
+{
+    NS_LOG_FUNCTION(this << defaultPort);
+}
+
+SinkApplication::~SinkApplication()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+void
+SinkApplication::SetLocal(const Address& addr)
+{
+    NS_LOG_FUNCTION(this << addr);
+    m_local = addr;
+}
+
+Address
+SinkApplication::GetLocal() const
+{
+    return m_local;
+}
+
+void
+SinkApplication::SetPort(uint32_t port)
+{
+    NS_LOG_FUNCTION(this << port);
+    if (port == INVALID_PORT)
+    {
+        return;
+    }
+    m_port = port;
+}
+
+uint32_t
+SinkApplication::GetPort() const
+{
+    return m_port;
+}
+
+} // Namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/sink-application.h ns-3.44/src/applications/model/sink-application.h
--- ns-3.43/src/applications/model/sink-application.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/applications/model/sink-application.h	2025-03-09 16:55:49.347370900 -0700
@@ -0,0 +1,89 @@
+/*
+ * Copyright (c) 2024 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef SINK_APPLICATION_H
+#define SINK_APPLICATION_H
+
+#include "ns3/address.h"
+#include "ns3/application.h"
+
+#include <limits>
+
+namespace ns3
+{
+
+/**
+ * @ingroup applications
+ * @brief Base class for sink applications.
+ *
+ * This class can be used as a base class for sink applications.
+ * A sink application is an application that is primarily used to only receive or echo packets.
+ *
+ * The main purpose of this base class application public API is to hold attributes for the local
+ * (IPv4 or IPv6) address and port to bind to.
+ *
+ * There are three ways that the port value can be configured. First, and most typically, through
+ * the use of a socket address (InetSocketAddress or Inet6SocketAddress) that is configured as the
+ * Local address to bind to. Second, through direct configuration of the Port attribute. Third,
+ * through the use of an optional constructor argument. If multiple of these port configuration
+ * methods are used, it is up to subclass definition which one takes precedence; in the existing
+ * subclasses in this directory, the port value configured in the Local socket address (if a socket
+ * address is configured there) will take precedence.
+ */
+class SinkApplication : public Application
+{
+  public:
+    /**
+     * @brief Get the type ID.
+     * @return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    /**
+     * Constructor
+     *
+     * @param defaultPort the default port number
+     */
+    SinkApplication(uint16_t defaultPort = 0);
+    ~SinkApplication() override;
+
+    static constexpr uint32_t INVALID_PORT{std::numeric_limits<uint32_t>::max()}; //!< invalid port
+
+  protected:
+    Address m_local; //!< Local address to bind to (address and port)
+    uint32_t m_port; //!< Local port to bind to
+
+  private:
+    /**
+     * @brief set the local address
+     * @param addr local address
+     */
+    virtual void SetLocal(const Address& addr);
+
+    /**
+     * @brief get the local address
+     * @return the local address
+     */
+    Address GetLocal() const;
+
+    /**
+     * @brief set the server port
+     * @param port server port
+     */
+    virtual void SetPort(uint32_t port);
+
+    /**
+     * @brief get the server port
+     * @return the server port
+     */
+    uint32_t GetPort() const;
+};
+
+} // namespace ns3
+
+#endif /* SINK_APPLICATION_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/source-application.cc ns-3.44/src/applications/model/source-application.cc
--- ns-3.43/src/applications/model/source-application.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/applications/model/source-application.cc	2025-03-09 16:55:49.347370900 -0700
@@ -0,0 +1,77 @@
+/*
+ * Copyright (c) 2024 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "source-application.h"
+
+#include "ns3/log.h"
+#include "ns3/uinteger.h"
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("SourceApplication");
+
+NS_OBJECT_ENSURE_REGISTERED(SourceApplication);
+
+TypeId
+SourceApplication::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::SourceApplication")
+            .SetParent<Application>()
+            .SetGroupName("Applications")
+            .AddAttribute(
+                "Remote",
+                "The address of the destination, made of the remote IP address and the "
+                "destination port",
+                AddressValue(),
+                MakeAddressAccessor(&SourceApplication::SetRemote, &SourceApplication::GetRemote),
+                MakeAddressChecker())
+            .AddAttribute("Local",
+                          "The Address on which to bind the socket. If not set, it is generated "
+                          "automatically when needed by the application.",
+                          AddressValue(),
+                          MakeAddressAccessor(&SourceApplication::m_local),
+                          MakeAddressChecker())
+            .AddAttribute("Tos",
+                          "The Type of Service used to send IPv4 packets. "
+                          "All 8 bits of the TOS byte are set (including ECN bits).",
+                          UintegerValue(0),
+                          MakeUintegerAccessor(&SourceApplication::m_tos),
+                          MakeUintegerChecker<uint8_t>());
+    return tid;
+}
+
+SourceApplication::SourceApplication()
+    : m_peer{}
+{
+    NS_LOG_FUNCTION(this);
+}
+
+SourceApplication::~SourceApplication()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+void
+SourceApplication::SetRemote(const Address& addr)
+{
+    NS_LOG_FUNCTION(this << addr);
+    if (!addr.IsInvalid())
+    {
+        m_peer = addr;
+    }
+}
+
+Address
+SourceApplication::GetRemote() const
+{
+    return m_peer;
+}
+
+} // Namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/source-application.h ns-3.44/src/applications/model/source-application.h
--- ns-3.43/src/applications/model/source-application.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/applications/model/source-application.h	2025-03-09 16:55:49.347370900 -0700
@@ -0,0 +1,66 @@
+/*
+ * Copyright (c) 2024 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef SOURCE_APPLICATION_H
+#define SOURCE_APPLICATION_H
+
+#include "ns3/address.h"
+#include "ns3/application.h"
+
+namespace ns3
+{
+
+/**
+ * @ingroup applications
+ * @brief Base class for source applications.
+ *
+ * This class can be used as a base class for source applications.
+ * A source application is one that primarily sources new data towards a single remote client
+ * address and port, and may also receive data (such as an HTTP server).
+ *
+ * The main purpose of this base class application public API is to provide a uniform way to
+ * configure remote and local addresses.
+ *
+ * Unlike the SinkApplication, the SourceApplication does not expose an individual Port attribute.
+ * Instead, the port values are embedded in the Local and Remote address attributes, which should be
+ * configured to an InetSocketAddress or Inet6SocketAddress value that contains the desired port
+ * number.
+ */
+class SourceApplication : public Application
+{
+  public:
+    /**
+     * @brief Get the type ID.
+     * @return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    SourceApplication();
+    ~SourceApplication() override;
+
+    /**
+     * @brief set the remote address
+     * @param addr remote address
+     */
+    virtual void SetRemote(const Address& addr);
+
+    /**
+     * @brief get the remote address
+     * @return the remote address
+     */
+    Address GetRemote() const;
+
+  protected:
+    Address m_peer;  //!< Peer address
+    Address m_local; //!< Local address to bind to
+    uint8_t m_tos;   //!< The packets Type of Service
+};
+
+} // namespace ns3
+
+#endif /* SOURCE_APPLICATION_H */
